# class NameError

Raised when a given name is invalid or undefined.

    puts foo

raises the exception:

    NameError: undefined local variable or method `foo' for main:Object

Since constant names must start with a capital:

    Integer.const_set :answer, 42

raises the exception:

    NameError: wrong constant name answer

### Public Class Methods

new(msg=nil, name=nil, receiver: nil) → name_error
Source

    static VALUE
    name_err_initialize(int argc, VALUE *argv, VALUE self)
    {
        ID keywords[1];
        VALUE values[numberof(keywords)], name, options;

        argc = rb_scan_args(argc, argv, "*:", NULL, &options);
        keywords[0] = id_receiver;
        rb_get_kwargs(options, keywords, 0, numberof(values), values);
        name = (argc > 1) ? argv[--argc] : Qnil;
        rb_call_super(argc, argv);
        name_err_init_attr(self, values[0], name);
        return self;
    }

Construct a new `NameError` exception. If given the name parameter may subsequently be examined using the `NameError#name` method. receiver parameter allows to pass object in context of which the error happened. Example:

    [1, 2, 3].method(:rject) # NameError with name "rject" and receiver: Array
    [1, 2, 3].singleton_method(:rject) # NameError with name "rject" and receiver: [1, 2, 3]

### Public Instance Methods

local_variables → array
Source

    static VALUE
    name_err_local_variables(VALUE self)
    {
        VALUE vars = rb_attr_get(self, id_local_variables);

        if (NIL_P(vars)) {
            VALUE iseqw = rb_attr_get(self, id_iseq);
            if (!NIL_P(iseqw)) vars = rb_iseqw_local_variables(iseqw);
            if (NIL_P(vars)) vars = rb_ary_new();
            rb_ivar_set(self, id_local_variables, vars);
        }
        return vars;
    }

Return a list of the local variable names defined where this `NameError` exception was raised.

Internal use only.

name → string or nil
Source

    static VALUE
    name_err_name(VALUE self)
    {
        return rb_attr_get(self, id_name);
    }

Return the name associated with this `NameError` exception.

receiver → object
Source

    static VALUE
    name_err_receiver(VALUE self)
    {
        VALUE recv = rb_ivar_lookup(self, id_recv, Qundef);
        if (!UNDEF_P(recv)) return recv;

        VALUE mesg = rb_attr_get(self, id_mesg);
        if (!rb_typeddata_is_kind_of(mesg, &name_err_mesg_data_type)) {
            rb_raise(rb_eArgError, "no receiver is available");
        }

        name_error_message_t *ptr;
        TypedData_Get_Struct(mesg, name_error_message_t, &name_err_mesg_data_type, ptr);
        return ptr->recv;
    }

Return the receiver associated with this `NameError` exception.